var SERVERROOT = '/';
if (!Date.now) {
	Date.now = function() { return new Date().getTime(); }
}
function getUnixTime() {
	return parseInt(Date.now()/1000);
}
var 	pageLoadTime = 0, connectInterval,
		lastTime = 0, lastVal = 0, startShakeTime = 0, endShakeTime = 0, endTick = 0,
		svrData = {dataVal: -1, unixTime: 0}, 
		isShaking = false;
		
async function getServerData() {
	return axios.get(SERVERROOT+'read.php?time='+pageLoadTime).then((res) => { return res.data; })
}
async function loadCard() {
	if(isShaking) return;
	
	var cardData = await axios.get(SERVERROOT+'card.php?start='+startShakeTime+'&end='+endShakeTime).then((res) => { return res.data; });
	if(cardData.cardNo!=-1) {
		$('#cardName').text('ใบเซียมซีที่ '+cardData.cardNo);
	} else {
		$('#cardName').text('พบข้อผิดพลาด');
	}
	$('#cardDesc').text(cardData.cardDesc);
	$('#resultLoading').fadeOut(250, function() { 
		$('#resultCard').fadeIn(250);
	});
	clearInterval(connectInterval);
	connectInterval = null;
}
function initLoadCard() {
	if(isShaking) return;
	$('#resultCard').hide();
	$('#resultLoading').show();
	$('#mainScreen').fadeOut(500, function() { 
		progVal(0, 5);
		$('#captionTxt').html('เขย่ากระบอกเพื่อดูโชคชะตาของคุณ!');
		$('#fortuneCanCtn').removeClass('shake');
		$('#resultScreen').fadeIn(500, loadCard);
	});
}
function progVal(a,b) {
	console.log(a,b);
	if (a>b) a = b;
	$('#progBar').css('width',a/b*100+'%');
}
function initShaking() {
	var initTime = getUnixTime();
	endTick = 0;
	connectInterval = setInterval(async () => {
		svrData = await getServerData();
		if (svrData.unixTime < initTime || svrData.unixTime == lastTime && svrData.dataVal == lastVal) return;
		console.log(svrData);
		lastTime = svrData.unixTime;
		lastVal = svrData.dataVal;
		
		if(svrData.dataVal > 300 || (svrData.dataVal > 10 && endTick==1) ) {
			endTick = 0;
			if(!isShaking) {
				isShaking = true;
				startShakeTime = svrData.unixTime;
				progVal(0, 5);
				$('#fortuneCanCtn').addClass('shake');
				$('#captionTxt').html('กำลังรวบรวมแรงศรัทธาของคุณ...');
			} else {
				progVal(svrData.unixTime - startShakeTime, 5);
				if(svrData.unixTime - startShakeTime >= 5) {
					isShaking = false;
					endShakeTime = svrData.unixTime;
					
					window.clearInterval(connectInterval);
					console.log("Valid shaked!");
					
					initLoadCard();
				}
			}
		} else {
			if(isShaking) {
				endTick++;
				if(endTick>1) { 
					isShaking = false;
					$('#fortuneCanCtn').removeClass('shake');
					
					if(svrData.unixTime - startShakeTime < 5)  {
						progVal(0, 5);
						console.log("Too short shaked!");
						$('#captionTxt').html('คุณเขย่าสั้นไป โปรดลองใหม่!');
					} else {
						endShakeTime = svrData.unixTime;
						
						window.clearInterval(connectInterval);
						console.log("Valid shaked!");
						
						initLoadCard();
					}
				} else {
					progVal(svrData.unixTime - startShakeTime, 5);
				}
			}
		}
	}, 370);
}
function connectDevice() {
	if(connectInterval) {
		return;
	}
	
	$('#locationScreen').fadeOut(500, function() { 
		$('#loadingScreen').fadeIn(500);
	});
	pageLoadTime = getUnixTime();
	var retries = 0, loadingTxt = 'กำลังผูกโยงกับกระบอกเซียมซี';
	
	connectInterval = setInterval(async () => {
		retries++;
		console.log("Connecting... Retries # ",retries);
		var tmpLoadText = loadingTxt;
		for(var i=0;i<(retries%4);i++) tmpLoadText+='.';
		$('#loadingStatus').text(tmpLoadText);
		svrData = await getServerData();
		if(svrData.dataVal!=-1 || retries >= 30) {
			window.clearInterval(connectInterval);
			if(retries >= 30) {
				$('#loadingP').html('<i class="fas fa-exclamation-triangle"></i>');
				$('#loadingStatus').html('<p>ไม่พบ "กระบอกเซียมซีอัจฉริยะ"<br><small>โปรดตรวจสอบการเชื่อมต่อ Wi-Fi ของอุปกรณ์</small></p>');
			} else {
				console.log("Connected");
				$('#loadingScreen').fadeOut(500, function() { 
					initShaking();
					$('#mainScreen').fadeIn(500);
				});
			}					
		}
	}, 500);
}
$('#homeBtn').click(function() {
	$('#resultScreen').fadeOut(500, function() { 
		$('#locationScreen').fadeIn(500);
	});
});